;---------------------------------------------------------------------------------------------
;     EEPROM 24c16 (2)
;
;
eeprom_write:
;
	cli
;
	clc
;
	mov	i2cdata,ZH	; High adres byte
	rol	i2cdata
	ori	i2cdata,0xA0	; Set device address
	rcall	_I2cS
;
	mov	i2cdata,ZL	; Low  adres byte
	rcall	_I2cW
;
	mov	i2cdata,temp_1
	rcall	_I2cW
	rcall	_I2cSp
;
	ldi	temp_1,0x05
	rcall	_Wms
;
	sei
;
	ret
;
;----------------------------------------------------------
;
rd_byte_24xxx:
eeprom_read:
;
	cli
;
	clc
;
	mov	i2cdata,ZH	; High adres byte
	rol	i2cdata
	ori	i2cdata,0xA0	; Set device address
	rcall	_I2cS
;
	mov	i2cdata,ZL	; Low  adres byte
	rcall	_I2cW
;
	mov	i2cdata,ZH	; High adres byte
	rol	i2cdata
	ori	i2cdata,0xA1	; Set device address

	rcall	_I2cRs
	rcall	_I2cR
	mov	temp_1,i2cdata
;
	rcall	_I2cSp
;
	sei
;
	ret
;
;*****************************************************
;
;
;  24xxx 4  
;
;
EE_wr_rf_4bytes:
;
;  temp_1  4  
;
	ldi	ZL,low(num_string)
	ldi	ZH,high(num_string)
	rcall	EEprom_read
	mov	XL,temp_1
	adiw	ZL,1
	rcall	EEprom_read
	mov	XH,temp_1
	or	temp_1,ZL
;
EE_WR_MASTER_4BYTES:
;
	ldi	ZL,low(ee_adres_ds_code)
	ldi	ZH,high(ee_adres_ds_code)
;
	tst	temp_1
	breq	wr_cnt_z4b
;
wr_find_cnt_4b:
;
	adiw	ZL,4
	sbiw	XL,1
	brne	wr_find_cnt_4b
;
master_key_wr:
wr_cnt_z4b:
;
	lds	temp_1,(DSRD+4)
	rcall	EEprom_write
	inc	ZL
;
	lds	temp_1,(DSRD+3)
	rcall	EEprom_write
	inc	ZL
;
	lds	temp_1,(DSRD+2)
	rcall	EEprom_write
	inc	ZL
;
	lds	temp_1,(DSRD+1)
	rcall	EEprom_write
;
;
	ret
;
;**********************************************************
;
;  24xxx 2000   key(4x500)
;
EE_erase_all:
;
	ldi	ZL,low(ee_adres_ds_code+4)
	ldi	ZH,high(ee_adres_ds_code+4)
;
	ldi	YL,low(2000)	; 500   4 
	ldi	YH,high(2000)	;
;
e_er_rf_c1:
;
	ldi	temp_1,0x00
;
	rcall	EEprom_write
;
	adiw	ZL,1
;
	sbiw	YL,1
	brne	e_er_rf_c1
;
	ret
;
;
;*******************************************************************
;      
;  24xxx
;
;
EE_compare_DS_paket:
;
	cbr	Flag_R,0b00001100	;2,3 
;
	ldi	YL,low(ee_adres_ds_code)
	ldi	YH,high(ee_adres_ds_code)
;
	ldi	XL,low(500)	;  -  500 
	ldi	XH,high(500)	;
;
e_comp_b1:
;
	mov	ZL,YL
	mov	ZH,YH
;
	lds	temp_2,(dsrd+4)
	rcall	EEprom_read
	cp	temp_1,temp_2
	brne	e_comp_b2
	inc	ZL
;
	lds	temp_2,(dsrd+3)
	rcall	EEprom_read
	cp	temp_1,temp_2
	brne	e_comp_b2
	inc	ZL
;
	lds	temp_2,(dsrd+2)
	rcall	EEprom_read
	cp	temp_1,temp_2
	brne	e_comp_b2
	inc	ZL
;
	lds	temp_2,(dsrd+1)
	rcall	EEprom_read
	cp	temp_1,temp_2
	brne	e_comp_b2
;
	cpi	YL,ee_adres_ds_code
	brne	key_code
;
;     -
;
	sbr	Flag_R,0b00000100	;2 
	ret
;
;     
;
key_code:
;
	sbr	Flag_R,0b00001000	;3 
	ret
;
e_comp_b2:
;
	adiw	YL,4
	sbiw	XL,1
	brne	e_comp_b1
;
;    
;
	ret
;
;
;**********************************************************
;
read_24xxx_all:
;
	ldi	ZL,0
	ldi	ZH,0
;
	ldi	YL,low(32)
	ldi	YH,high(32)
;
i2c_test1:
;
	ldi	temp_3,16
;
i2c_t:
	push	temp_3
	rcall	rd_byte_24xxx
	pop	temp_3
;
	adiw	ZL,1
	sbiw	YL,1
	breq	read_24xxx_end
;
	dec	temp_3
	brne	i2c_t
;
	rjmp	i2c_test1
;
read_24xxx_end:
;
	ret
;
;***********************************************************