;------------------------------------------------------------------------------
;      I2C
;
;.def	i2c_temp	   	= R23
.def	i2cdata	   	= R17	
;
.equ	SCL		= 5	; SCL Pin number (port D)
.equ	SDA		= 6	; SDA Pin number (port D)
;
;
;.set    	i2c_PORTx  	= PORTD
;.set    	i2c_DDRx   	= DDRD
;.set    	i2c_PINx   	= PIND
;
;
;////// I2cRepStart ///////////////////////
_I2cRs:
;
	sbi	DDRD,SCL
	cbi	DDRD,SDA
	rcall	wait_5us
	cbi	DDRD,SCL
	rcall	wait_5us

;////// I2cStart //////////////////////////
_I2cS:
	sbi	DDRD,SDA
	rcall	wait_5us

;////// I2cWrite //////////////////////////
_I2cW:
	sec
	rol	i2cdata
	rjmp	_I2cWf
_I2cWb:
	lsl	i2cdata
_I2cWf:
	breq	_I2cGa
	sbi	DDRD,SCL
	brcc	_I2cW0
	cbi	DDRD,SDA
	rjmp	_I2cW1
_I2cW0:
	sbi	DDRD,SDA
_I2cW1:
	rcall	wait_5us
	cbi	DDRD,SCL
	rcall	wait_5us
	rjmp	_I2cWb

;////// I2cGetAck /////////////////////////
_I2cGa:
	sbi	DDRD,SCL
	cbi	DDRD,SDA
	rcall	wait_5us
	cbi	DDRD,SCL
_I2cGw:
	sbis	PIND,SCL
	rjmp	_I2cGw
	clc
	sbic	PIND,SDA
	sec
	rcall	wait_5us
	ret

;////// I2cRead ///////////////////////////
_I2cR:
;
	ldi	i2cdata,0x01
_I2cRb:
	sbi	DDRD,SCL
	cbi	DDRD,SDA
	rcall	wait_5us
	cbi	DDRD,SCL
	rcall	wait_5us
	clc
	sbic	PIND,SDA
	sec
	rol	i2cdata
	brcc	_I2cRb

;////// I2cPutAck /////////////////////////
_I2cPa:
;
_I2cP0:
	sbi	DDRD,SDA
_I2cP1:
	rcall	wait_5us
	cbi	DDRD,SCL
_I2cPw:
	sbis	PIND,SCL
	rjmp	_I2cPw
	rcall	wait_5us
	ret

;////// I2cStop ///////////////////////////
_I2cSp:
	sbi	DDRD,SCL
	sbi	DDRD,SDA
	rcall	wait_5us
	cbi	DDRD,SCL
	rcall	wait_5us
	cbi	DDRD,SDA
	rcall	wait_5us
	ret

;////// _Waitms ///////////////////////////
_Wms:
	ldi	temp_2,0x14
_Wms1:
	ldi	temp_3,0x85
_Wms2:
	dec	temp_3
	brne	_Wms2
	dec	temp_2
	brne	_Wms1
	dec	temp_1
	brne	_Wms
	ret

;////// Wait 5us //////////////////////////
wait_5us:
	push	temp
	ldi	temp,8
w_us_loop:
	dec	temp
	brne	w_us_loop
	pop	temp
	ret
;