;--------------------------------------------------------------------------------------------
;
;
;
;
;
ReadDS:
;
	ldi	temp_1,0
	sts	(crc),temp_1
	sts	(crc2),temp_1
;
	cbr	Flag_R,0b00000001
;
	rcall	Read_DS1990A
;
	brts	rd1_1990
;
	ret
;
rd1_1990:
;
	ldi	YL,low(dsrd)
	ldi	YH,high(dsrd)
;
	ldi	ZL,low(dsrd2)
	ldi	ZH,high(dsrd2)
;
	ldi	temp,8
;
rd1_move_rd2:
;
	ld	temp_1,Y+
	st	Z+,temp_1
	dec	temp
	brne	rd1_move_rd2
;
	rcall	Read_DS1990A
;
	brts	rd2_1990
	ret
;
rd2_1990:
;
	ldi	YL,low(dsrd)
	ldi	YH,high(dsrd)
;
	ldi	ZL,low(dsrd2)
	ldi	ZH,high(dsrd2)
;
	ldi	temp,8
;
rd1_rd2_compare:
;
	ld	temp_1,Y+
	ld	temp_2,Z+
;
	cpse	temp_1,temp_2
	ret
;
	dec	temp
	brne	rd1_rd2_compare
;
	sbr	Flag_R,0b00000001
;
	ret
;
;-------------------------------------
;
Read_DS1990A:
;
	rcall	_1Wrs0
	brts	ds_rst_yes
	ret
ds_rst_yes:
;
;
;-Wwrite &h33-read rom command--
;
	ldi	reg_wr_ds,0x33
	rcall	_1Ww0
;
	ldi	ZL,low(dsrd)
	ldi	ZH,high(dsrd)
;
	ldi	temp_1,8
;
	clt
;
loop_ds_read:
;
	push	temp_1
;
	rcall	_1Wr0
	st	Z+,reg_rd_ds
	mov	R1,reg_rd_ds
	cpi	temp_1,2
	brsh	crc_up
	rjmp	crc_no
crc_up:	
	rcall	_Crc8
crc_no:
	pop	temp_1
	dec	temp_1
	brne	loop_ds_read
;
	lds	temp_1,(crc)
	lds	temp_2,(dsrd+7)
;
	cpse	temp_1,temp_2
	rjmp	rere
;
	cpi	temp_1,0
	breq	rere
;
	cpi	temp_1,0xFF
	breq	rere
;
	set
;	sbr	Flag_R,0b00000001
rere:
;
	ret
;
;*************************************************
;
;
;--------1Wreset---------
;      
;
_1Wrs0:
	clt
	sbi	DDRD,4
	cbi	PORTD,4
	ldi	temp_1,50
	rcall	_Wus
	cbi	DDRD,4
	ldi	temp_1,7
	rcall	_Wus
	sbic	PIND,4
	ret
	ldi	temp_1,50
	rcall	_Wus
	set
	ret
;
;--------1Wwrite---------
;      reg_wr_ds
;
_1Ww0:
	ldi	temp_3,8
	sbi	DDRD, 4
_1Ww10:	
	cbi	PORTD,4
	rcall	_W5
	ror	reg_wr_ds
	brcc	_1Ww20
	sbi	PORTD,4
_1Ww20:
	ldi	temp_1,5
	rcall	_Wus
	sbi	PORTD,4
	rcall	_W5
	dec	temp_3
	brne	_1Ww10
	ret
;
;------- 1Wread ---------
;     reg_rd_ds
;
_1Wr0:
	ldi	temp,8
_1Wr10:
	cbi	PORTD,4
	rcall	_W5
	cbi	DDRD,4
	ldi	temp_1,2
	rcall	_Wus
	clc
	sbic	PIND,4
	sec
	ror	reg_rd_ds
	ldi	temp_1,5
	rcall	_Wus
	sbi	PORTD,4
	sbi	DDRD,4
	rcall	_W5
	dec	temp
	brne	_1Wr10
;
	ret
;
;--------CalcCrc8---------
;   
;
;.........................................................................
; DS1990A CRC GENERATOR
; IN: R1
; USE: Reg_r20, Reg_r18, R3, R1
;.........................................................................
;
_Crc8:
;
	LDI	Reg_r20,8
	LDI	Reg_r18,0x18
	PUSH	R1
                                    
CRC_L:
	lds	R3,CRC		;CRC
	EOR	R1,R3
	ROR	R1
	MOV	R1,R3
	BRCC	ZERO
	EOR	R1,Reg_r18
ZERO:
	ROR	R1
	sts	CRC,R1
	POP	R1
	SEC
	SBRS	R1,0
	CLC
	ROR	R1
	PUSH	R1
	DEC	Reg_r20
	BRNE	CRC_L
;
	POP	R1
;                                   
	RET
;
;---------waitus-----------
_wus:
	ldi	temp_2,31
_wus1:
	dec	temp_2
	brne	_wus1
	dec	temp_1
	brne	_wus
	ret
;
;--------- Wait 5us----------
_W5:
	ldi	temp_1,10
_W51:
	dec	temp_1
	brne	_W51
	ret
;